# -*- encoding: utf-8 -*-

Gem::Specification.new do |s|
  s.name = %q{passenger}
  s.version = "2.1.3"

  s.required_rubygems_version = Gem::Requirement.new(">= 0") if s.respond_to? :required_rubygems_version=
  s.authors = ["Phusion - http://www.phusion.nl/"]
  s.date = %q{2009-03-30}
  s.description = %q{Passenger is an Apache module for Ruby on Rails support.}
  s.email = %q{info@phusion.nl}
  s.executables = ["passenger-spawn-server", "passenger-install-apache2-module", "passenger-config", "passenger-memory-stats", "passenger-make-enterprisey", "passenger-status", "passenger-stress-test"]
  s.extensions = ["ext/phusion_passenger/extconf.rb"]
  s.extra_rdoc_files = ["README"]
  s.files = ["Rakefile", "README", "DEVELOPERS.TXT", "LICENSE", "INSTALL", "NEWS", "lib/phusion_passenger/abstract_server.rb", "lib/phusion_passenger/exceptions.rb", "lib/phusion_passenger/dependencies.rb", "lib/phusion_passenger/wsgi/application_spawner.rb", "lib/phusion_passenger/abstract_server_collection.rb", "lib/phusion_passenger/simple_benchmarking.rb", "lib/phusion_passenger/console_text_template.rb", "lib/phusion_passenger/application.rb", "lib/phusion_passenger/admin_tools/control_process.rb", "lib/phusion_passenger/platform_info.rb", "lib/phusion_passenger/message_channel.rb", "lib/phusion_passenger/rack/application_spawner.rb", "lib/phusion_passenger/rack/request_handler.rb", "lib/phusion_passenger/constants.rb", "lib/phusion_passenger/spawn_manager.rb", "lib/phusion_passenger/utils.rb", "lib/phusion_passenger/events.rb", "lib/phusion_passenger/admin_tools.rb", "lib/phusion_passenger/railz/application_spawner.rb", "lib/phusion_passenger/railz/request_handler.rb", "lib/phusion_passenger/railz/cgi_fixed.rb", "lib/phusion_passenger/railz/framework_spawner.rb", "lib/phusion_passenger/html_template.rb", "lib/phusion_passenger/abstract_request_handler.rb", "lib/phusion_passenger/wsgi/request_handler.py", "lib/phusion_passenger/templates/apache_must_be_compiled_with_compatible_mpm.txt.erb", "lib/phusion_passenger/templates/app_init_error.html.erb", "lib/phusion_passenger/templates/welcome.txt.erb", "lib/phusion_passenger/templates/apache2_config_snippets.txt.erb", "lib/phusion_passenger/templates/load_error.html.erb", "lib/phusion_passenger/templates/invalid_app_root.html.erb", "lib/phusion_passenger/templates/general_error.html.erb", "lib/phusion_passenger/templates/deployment_example.txt.erb", "lib/phusion_passenger/templates/run_installer_as_root.txt.erb", "lib/phusion_passenger/templates/database_error.html.erb", "lib/phusion_passenger/templates/app_exited_during_initialization.html.erb", "lib/phusion_passenger/templates/framework_init_error.html.erb", "lib/phusion_passenger/templates/error_layout.css", "lib/phusion_passenger/templates/version_not_found.html.erb", "lib/phusion_passenger/templates/error_layout.html.erb", "lib/phusion_passenger/templates/no_write_permission_to_passenger_root.txt.erb", "lib/phusion_passenger/templates/possible_solutions_for_compilation_and_installation_problems.txt.erb", "bin/passenger-stress-test", "bin/passenger-make-enterprisey", "bin/passenger-install-apache2-module", "bin/passenger-memory-stats", "bin/passenger-status", "bin/passenger-spawn-server", "bin/passenger-config", "doc/Users guide.html", "doc/Security of user switching support.html", "doc/Users guide.txt", "doc/images", "doc/Architectural overview.html", "doc/Doxyfile", "doc/cxxapi", "doc/Security of user switching support.txt", "doc/template", "doc/rdoc", "doc/definitions.h", "doc/Architectural overview.txt", "doc/ApplicationPool algorithm.txt", "doc/images/smart-lv2.png", "doc/images/conservative_spawning.svg", "doc/images/typical_isolated_web_application.png", "doc/images/conservative_spawning.png", "doc/images/spawn_server_architecture.svg", "doc/images/phusion_banner.png", "doc/images/typical_isolated_web_application.svg", "doc/images/spawn_server_architecture.png", "doc/images/by_sa.png", "doc/images/icons", "doc/images/passenger_architecture.svg", "doc/images/passenger_architecture.png", "doc/images/smart-lv2.svg", "doc/cxxapi/classPassenger_1_1SystemException__inherit__graph.png", "doc/cxxapi/ftv2node.png", "doc/cxxapi/classClient.html", "doc/cxxapi/inherit__graph__11.png", "doc/cxxapi/inherit__graph__13.map", "doc/cxxapi/inherit__graph__2.md5", "doc/cxxapi/classPassenger_1_1Application_1_1Session.html", "doc/cxxapi/inherit__graph__14.map", "doc/cxxapi/structPassenger_1_1AnythingToString_3_01vector_3_01string_01_4_01_4.html", "doc/cxxapi/SpawnManager_8h-source.html", "doc/cxxapi/classHooks.html", "doc/cxxapi/inherit__graph__18.md5", "doc/cxxapi/inherit__graph__3.png", "doc/cxxapi/inherit__graph__6.png", "doc/cxxapi/inherit__graph__9.png", "doc/cxxapi/inherit__graph__18.map", "doc/cxxapi/inherit__graph__13.md5", "doc/cxxapi/inherit__graph__10.md5", "doc/cxxapi/inherit__graph__14.png", "doc/cxxapi/inherit__graph__0.md5", "doc/cxxapi/classPassenger_1_1FileNotFoundException__inherit__graph.map", "doc/cxxapi/classPassenger_1_1FileChecker.html", "doc/cxxapi/classPassenger_1_1IOException.html", "doc/cxxapi/classHooks-members.html", "doc/cxxapi/group__Hooks.html", "doc/cxxapi/inherit__graph__8.png", "doc/cxxapi/classPassenger_1_1BufferedUpload-members.html", "doc/cxxapi/inherit__graph__8.map", "doc/cxxapi/inherit__graph__16.md5", "doc/cxxapi/classPassenger_1_1StandardApplicationPool__inherit__graph.png", "doc/cxxapi/FileChecker_8h-source.html", "doc/cxxapi/inherit__graph__14.md5", "doc/cxxapi/classPassenger_1_1IOException__inherit__graph.md5", "doc/cxxapi/inherit__graph__4.md5", "doc/cxxapi/tree.html", "doc/cxxapi/Hooks_8h-source.html", "doc/cxxapi/inherit__graph__21.md5", "doc/cxxapi/ApplicationPoolServer_8h-source.html", "doc/cxxapi/classPassenger_1_1StandardApplicationPool__inherit__graph.md5", "doc/cxxapi/structPassenger_1_1PoolOptions.html", "doc/cxxapi/inherit__graph__11.md5", "doc/cxxapi/inherit__graph__9.map", "doc/cxxapi/inherit__graph__5.map", "doc/cxxapi/ftv2link.png", "doc/cxxapi/Application_8h-source.html", "doc/cxxapi/classPassenger_1_1BufferedUpload.html", "doc/cxxapi/structPassenger_1_1AnythingToString_3_01vector_3_01string_01_4_01_4-members.html", "doc/cxxapi/inherit__graph__6.map", "doc/cxxapi/ftv2vertline.png", "doc/cxxapi/classPassenger_1_1DummySpawnManager-members.html", "doc/cxxapi/inherit__graph__4.png", "doc/cxxapi/inherit__graph__15.md5", "doc/cxxapi/classPassenger_1_1MessageChannel.html", "doc/cxxapi/classPassenger_1_1Application.html", "doc/cxxapi/group__Configuration.html", "doc/cxxapi/ftv2mlastnode.png", "doc/cxxapi/structPassenger_1_1AnythingToString.html", "doc/cxxapi/inherit__graph__3.map", "doc/cxxapi/ftv2pnode.png", "doc/cxxapi/classPassenger_1_1FileNotFoundException-members.html", "doc/cxxapi/classPassenger_1_1FileSystemException-members.html", "doc/cxxapi/doxygen.css", "doc/cxxapi/definitions_8h-source.html", "doc/cxxapi/classPassenger_1_1DirectoryMapper-members.html", "doc/cxxapi/annotated.html", "doc/cxxapi/inherit__graph__6.md5", "doc/cxxapi/inherit__graph__7.png", "doc/cxxapi/classPassenger_1_1ApplicationPool.html", "doc/cxxapi/inherit__graph__16.png", "doc/cxxapi/classPassenger_1_1SystemException__inherit__graph.md5", "doc/cxxapi/inherits.html", "doc/cxxapi/MessageChannel_8h-source.html", "doc/cxxapi/classPassenger_1_1ConfigurationException.html", "doc/cxxapi/classPassenger_1_1ConfigurationException-members.html", "doc/cxxapi/classPassenger_1_1FileNotFoundException__inherit__graph.md5", "doc/cxxapi/inherit__graph__19.md5", "doc/cxxapi/inherit__graph__20.map", "doc/cxxapi/index.html", "doc/cxxapi/inherit__graph__2.png", "doc/cxxapi/tab_l.gif", "doc/cxxapi/classPassenger_1_1RuntimeException.html", "doc/cxxapi/structPassenger_1_1PoolOptions-members.html", "doc/cxxapi/inherit__graph__0.png", "doc/cxxapi/ftv2blank.png", "doc/cxxapi/ftv2lastnode.png", "doc/cxxapi/inherit__graph__21.map", "doc/cxxapi/Bucket_8h-source.html", "doc/cxxapi/inherit__graph__8.md5", "doc/cxxapi/classPassenger_1_1StandardApplicationPool__inherit__graph.map", "doc/cxxapi/inherit__graph__18.png", "doc/cxxapi/tab_b.gif", "doc/cxxapi/classPassenger_1_1BusyException.html", "doc/cxxapi/classPassenger_1_1IOException__inherit__graph.map", "doc/cxxapi/inherit__graph__7.md5", "doc/cxxapi/files.html", "doc/cxxapi/group__Core.png", "doc/cxxapi/inherit__graph__16.map", "doc/cxxapi/inherit__graph__9.md5", "doc/cxxapi/graph_legend.html", "doc/cxxapi/classPassenger_1_1SystemTime.html", "doc/cxxapi/group__Configuration.png", "doc/cxxapi/classClient-members.html", "doc/cxxapi/classPassenger_1_1FileNotFoundException.html", "doc/cxxapi/classPassenger_1_1SystemException__inherit__graph.map", "doc/cxxapi/DirectoryMapper_8h-source.html", "doc/cxxapi/modules.html", "doc/cxxapi/classPassenger_1_1BusyException-members.html", "doc/cxxapi/inherit__graph__20.png", "doc/cxxapi/classPassenger_1_1SpawnException-members.html", "doc/cxxapi/doxygen.png", "doc/cxxapi/classPassenger_1_1FileSystemException.html", "doc/cxxapi/classPassenger_1_1SystemException-members.html", "doc/cxxapi/inherit__graph__1.map", "doc/cxxapi/inherit__graph__10.png", "doc/cxxapi/classPassenger_1_1ApplicationPool__inherit__graph.md5", "doc/cxxapi/classPassenger_1_1SystemException.html", "doc/cxxapi/inherit__graph__2.map", "doc/cxxapi/classPassenger_1_1RuntimeException-members.html", "doc/cxxapi/classPassenger_1_1StandardApplicationPool.html", "doc/cxxapi/inherit__graph__4.map", "doc/cxxapi/classPassenger_1_1Application_1_1Session-members.html", "doc/cxxapi/functions.html", "doc/cxxapi/functions_vars.html", "doc/cxxapi/group__Support.html", "doc/cxxapi/CachedFileStat_8h-source.html", "doc/cxxapi/inherit__graph__11.map", "doc/cxxapi/tab_r.gif", "doc/cxxapi/classPassenger_1_1SystemTime-members.html", "doc/cxxapi/inherit__graph__17.map", "doc/cxxapi/classPassenger_1_1ApplicationPoolServer.html", "doc/cxxapi/ApplicationPool_8h-source.html", "doc/cxxapi/inherit__graph__17.md5", "doc/cxxapi/DummySpawnManager_8h-source.html", "doc/cxxapi/classPassenger_1_1ApplicationPool__inherit__graph.png", "doc/cxxapi/inherit__graph__13.png", "doc/cxxapi/inherit__graph__15.png", "doc/cxxapi/classPassenger_1_1IOException__inherit__graph.png", "doc/cxxapi/ftv2folderclosed.png", "doc/cxxapi/classPassenger_1_1FileNotFoundException__inherit__graph.png", "doc/cxxapi/inherit__graph__3.md5", "doc/cxxapi/inherit__graph__10.map", "doc/cxxapi/classPassenger_1_1ApplicationPool-members.html", "doc/cxxapi/inherit__graph__19.map", "doc/cxxapi/inherit__graph__7.map", "doc/cxxapi/inherit__graph__21.png", "doc/cxxapi/ftv2mnode.png", "doc/cxxapi/structPassenger_1_1AnythingToString-members.html", "doc/cxxapi/classPassenger_1_1ApplicationPool__inherit__graph.map", "doc/cxxapi/tabs.css", "doc/cxxapi/classPassenger_1_1ApplicationPoolServer-members.html", "doc/cxxapi/functions_func.html", "doc/cxxapi/classPassenger_1_1DirectoryMapper.html", "doc/cxxapi/Configuration_8h-source.html", "doc/cxxapi/inherit__graph__12.png", "doc/cxxapi/SystemTime_8h-source.html", "doc/cxxapi/StandardApplicationPool_8h-source.html", "doc/cxxapi/classPassenger_1_1SpawnException.html", "doc/cxxapi/inherit__graph__12.map", "doc/cxxapi/inherit__graph__1.png", "doc/cxxapi/classPassenger_1_1FileSystemException__inherit__graph.md5", "doc/cxxapi/graph_legend.png", "doc/cxxapi/classPassenger_1_1SpawnManager.html", "doc/cxxapi/graph_legend.dot", "doc/cxxapi/classPassenger_1_1FileSystemException__inherit__graph.map", "doc/cxxapi/Utils_8h-source.html", "doc/cxxapi/hierarchy.html", "doc/cxxapi/ftv2plastnode.png", "doc/cxxapi/Logging_8h-source.html", "doc/cxxapi/inherit__graph__12.md5", "doc/cxxapi/inherit__graph__20.md5", "doc/cxxapi/PoolOptions_8h-source.html", "doc/cxxapi/Exceptions_8h-source.html", "doc/cxxapi/inherit__graph__5.png", "doc/cxxapi/inherit__graph__15.map", "doc/cxxapi/main.html", "doc/cxxapi/classPassenger_1_1IOException-members.html", "doc/cxxapi/group__Core.html", "doc/cxxapi/inherit__graph__17.png", "doc/cxxapi/inherit__graph__19.png", "doc/cxxapi/classPassenger_1_1StandardApplicationPool-members.html", "doc/cxxapi/functions_type.html", "doc/cxxapi/inherit__graph__0.map", "doc/cxxapi/inherit__graph__1.md5", "doc/cxxapi/inherit__graph__5.md5", "doc/cxxapi/ftv2folderopen.png", "doc/cxxapi/classPassenger_1_1FileSystemException__inherit__graph.png", "doc/cxxapi/classPassenger_1_1FileChecker-members.html", "doc/cxxapi/ftv2doc.png", "doc/cxxapi/classPassenger_1_1MessageChannel-members.html", "doc/cxxapi/classPassenger_1_1DummySpawnManager.html", "doc/cxxapi/classPassenger_1_1SpawnManager-members.html", "doc/cxxapi/group__Exceptions.html", "doc/cxxapi/group__Hooks.png", "doc/cxxapi/classPassenger_1_1Application-members.html", "doc/template/horo.rb", "doc/rdoc/files", "doc/rdoc/classes", "doc/rdoc/index.html", "doc/rdoc/fr_file_index.html", "doc/rdoc/fr_class_index.html", "doc/rdoc/rdoc-style.css", "doc/rdoc/created.rid", "doc/rdoc/fr_method_index.html", "doc/images/icons/next.png", "doc/images/icons/callouts", "doc/images/icons/README", "doc/images/icons/prev.png", "doc/images/icons/up.png", "doc/images/icons/note.png", "doc/images/icons/warning.png", "doc/images/icons/example.png", "doc/images/icons/tip.png", "doc/images/icons/caution.png", "doc/images/icons/important.png", "doc/images/icons/home.png", "doc/rdoc/files/lib", "doc/rdoc/files/README.html", "doc/rdoc/files/ext", "doc/rdoc/files/misc", "doc/rdoc/files/DEVELOPERS_TXT.html", "doc/rdoc/classes/ConditionVariable.html", "doc/rdoc/classes/RakeExtensions.html", "doc/rdoc/classes/PlatformInfo.html", "doc/rdoc/classes/Signal.html", "doc/rdoc/classes/PhusionPassenger", "doc/rdoc/classes/GC.html", "doc/rdoc/classes/PhusionPassenger.html", "doc/rdoc/classes/IO.html", "doc/rdoc/classes/Exception.html", "doc/images/icons/callouts/13.png", "doc/images/icons/callouts/2.png", "doc/images/icons/callouts/3.png", "doc/images/icons/callouts/10.png", "doc/images/icons/callouts/6.png", "doc/images/icons/callouts/15.png", "doc/images/icons/callouts/8.png", "doc/images/icons/callouts/12.png", "doc/images/icons/callouts/9.png", "doc/images/icons/callouts/11.png", "doc/images/icons/callouts/7.png", "doc/images/icons/callouts/5.png", "doc/images/icons/callouts/4.png", "doc/images/icons/callouts/14.png", "doc/images/icons/callouts/1.png", "doc/rdoc/files/lib/phusion_passenger", "doc/rdoc/files/ext/phusion_passenger", "doc/rdoc/files/misc/rake", "doc/rdoc/classes/PhusionPassenger/VersionNotFound.html", "doc/rdoc/classes/PhusionPassenger/WSGI", "doc/rdoc/classes/PhusionPassenger/AbstractRequestHandler.html", "doc/rdoc/classes/PhusionPassenger/MessageChannel.html", "doc/rdoc/classes/PhusionPassenger/Railz", "doc/rdoc/classes/PhusionPassenger/Utils.html", "doc/rdoc/classes/PhusionPassenger/AbstractServer.html", "doc/rdoc/classes/PhusionPassenger/WSGI.html", "doc/rdoc/classes/PhusionPassenger/Railz.html", "doc/rdoc/classes/PhusionPassenger/AbstractServer", "doc/rdoc/classes/PhusionPassenger/AbstractServerCollection.html", "doc/rdoc/classes/PhusionPassenger/FrameworkInitError.html", "doc/rdoc/classes/PhusionPassenger/AdminTools", "doc/rdoc/classes/PhusionPassenger/InitializationError.html", "doc/rdoc/classes/PhusionPassenger/AppInitError.html", "doc/rdoc/classes/PhusionPassenger/Rack.html", "doc/rdoc/classes/PhusionPassenger/Rack", "doc/rdoc/classes/PhusionPassenger/Application.html", "doc/rdoc/classes/PhusionPassenger/SpawnManager.html", "doc/rdoc/classes/PhusionPassenger/InvalidPath.html", "doc/rdoc/classes/PhusionPassenger/ConsoleTextTemplate.html", "doc/rdoc/classes/PhusionPassenger/UnknownError.html", "doc/rdoc/classes/PhusionPassenger/NativeSupport.html", "doc/rdoc/classes/PhusionPassenger/AdminTools.html", "doc/rdoc/classes/PhusionPassenger/HTMLTemplate.html", "doc/rdoc/files/lib/phusion_passenger/exceptions_rb.html", "doc/rdoc/files/lib/phusion_passenger/wsgi", "doc/rdoc/files/lib/phusion_passenger/utils_rb.html", "doc/rdoc/files/lib/phusion_passenger/dependencies_rb.html", "doc/rdoc/files/lib/phusion_passenger/admin_tools", "doc/rdoc/files/lib/phusion_passenger/platform_info_rb.html", "doc/rdoc/files/lib/phusion_passenger/constants_rb.html", "doc/rdoc/files/lib/phusion_passenger/rack", "doc/rdoc/files/lib/phusion_passenger/console_text_template_rb.html", "doc/rdoc/files/lib/phusion_passenger/application_rb.html", "doc/rdoc/files/lib/phusion_passenger/admin_tools_rb.html", "doc/rdoc/files/lib/phusion_passenger/abstract_server_collection_rb.html", "doc/rdoc/files/lib/phusion_passenger/railz", "doc/rdoc/files/lib/phusion_passenger/abstract_server_rb.html", "doc/rdoc/files/lib/phusion_passenger/message_channel_rb.html", "doc/rdoc/files/lib/phusion_passenger/events_rb.html", "doc/rdoc/files/lib/phusion_passenger/spawn_manager_rb.html", "doc/rdoc/files/lib/phusion_passenger/simple_benchmarking_rb.html", "doc/rdoc/files/lib/phusion_passenger/html_template_rb.html", "doc/rdoc/files/lib/phusion_passenger/abstract_request_handler_rb.html", "doc/rdoc/files/ext/phusion_passenger/native_support_c.html", "doc/rdoc/files/misc/rake/extensions_rb.html", "doc/rdoc/classes/PhusionPassenger/WSGI/ApplicationSpawner.html", "doc/rdoc/classes/PhusionPassenger/Railz/ApplicationSpawner.html", "doc/rdoc/classes/PhusionPassenger/Railz/ApplicationSpawner", "doc/rdoc/classes/PhusionPassenger/Railz/FrameworkSpawner", "doc/rdoc/classes/PhusionPassenger/Railz/FrameworkSpawner.html", "doc/rdoc/classes/PhusionPassenger/Railz/CGIFixed.html", "doc/rdoc/classes/PhusionPassenger/Railz/RequestHandler.html", "doc/rdoc/classes/PhusionPassenger/AbstractServer/ServerNotStarted.html", "doc/rdoc/classes/PhusionPassenger/AbstractServer/ServerError.html", "doc/rdoc/classes/PhusionPassenger/AbstractServer/ServerAlreadyStarted.html", "doc/rdoc/classes/PhusionPassenger/AbstractServer/UnknownMessage.html", "doc/rdoc/classes/PhusionPassenger/AdminTools/ControlProcess", "doc/rdoc/classes/PhusionPassenger/AdminTools/ControlProcess.html", "doc/rdoc/classes/PhusionPassenger/Rack/ApplicationSpawner.html", "doc/rdoc/classes/PhusionPassenger/Rack/RequestHandler.html", "doc/rdoc/files/lib/phusion_passenger/wsgi/application_spawner_rb.html", "doc/rdoc/files/lib/phusion_passenger/admin_tools/control_process_rb.html", "doc/rdoc/files/lib/phusion_passenger/rack/request_handler_rb.html", "doc/rdoc/files/lib/phusion_passenger/rack/application_spawner_rb.html", "doc/rdoc/files/lib/phusion_passenger/railz/cgi_fixed_rb.html", "doc/rdoc/files/lib/phusion_passenger/railz/framework_spawner_rb.html", "doc/rdoc/files/lib/phusion_passenger/railz/request_handler_rb.html", "doc/rdoc/files/lib/phusion_passenger/railz/application_spawner_rb.html", "doc/rdoc/classes/PhusionPassenger/Railz/ApplicationSpawner/Error.html", "doc/rdoc/classes/PhusionPassenger/Railz/FrameworkSpawner/Error.html", "doc/rdoc/classes/PhusionPassenger/AdminTools/ControlProcess/Instance.html", "man/passenger-make-enterprisey.8", "man/passenger-status.8", "man/passenger-config.1", "man/passenger-memory-stats.8", "man/passenger-stress-test.1", "debian/prerm", "debian/postinst", "debian/compat", "debian/control", "ext/apache2/Utils.cpp", "ext/apache2/CachedFileStat.cpp", "ext/apache2/Bucket.cpp", "ext/apache2/Hooks.cpp", "ext/apache2/Configuration.cpp", "ext/apache2/SystemTime.cpp", "ext/apache2/Logging.cpp", "ext/apache2/ApplicationPoolServerExecutable.cpp", "ext/apache2/Bucket.h", "ext/apache2/SystemTime.h", "ext/apache2/PoolOptions.h", "ext/apache2/DirectoryMapper.h", "ext/apache2/FileChecker.h", "ext/apache2/Hooks.h", "ext/apache2/Utils.h", "ext/apache2/ApplicationPoolServer.h", "ext/apache2/ApplicationPool.h", "ext/apache2/SpawnManager.h", "ext/apache2/Application.h", "ext/apache2/CachedFileStat.h", "ext/apache2/MessageChannel.h", "ext/apache2/Logging.h", "ext/apache2/DummySpawnManager.h", "ext/apache2/StandardApplicationPool.h", "ext/apache2/Configuration.h", "ext/apache2/Exceptions.h", "ext/apache2/mod_passenger.c", "ext/apache2/LICENSE-CNRI.TXT", "ext/boost/next_prior.hpp", "ext/boost/cstdint.hpp", "ext/boost/checked_delete.hpp", "ext/boost/utility.hpp", "ext/boost/none.hpp", "ext/boost/tokenizer.hpp", "ext/boost/call_traits.hpp", "ext/boost/optional.hpp", "ext/boost/function_equal.hpp", "ext/boost/static_assert.hpp", "ext/boost/assert.hpp", "ext/boost/operators.hpp", "ext/boost/bind.hpp", "ext/boost/none_t.hpp", "ext/boost/enable_shared_from_this.hpp", "ext/boost/get_pointer.hpp", "ext/boost/shared_ptr.hpp", "ext/boost/token_iterator.hpp", "ext/boost/ref.hpp", "ext/boost/noncopyable.hpp", "ext/boost/type.hpp", "ext/boost/is_placeholder.hpp", "ext/boost/non_type.hpp", "ext/boost/concept_check.hpp", "ext/boost/implicit_cast.hpp", "ext/boost/limits.hpp", "ext/boost/current_function.hpp", "ext/boost/throw_exception.hpp", "ext/boost/iterator.hpp", "ext/boost/function.hpp", "ext/boost/lexical_cast.hpp", "ext/boost/thread.hpp", "ext/boost/config.hpp", "ext/boost/weak_ptr.hpp", "ext/boost/io_fwd.hpp", "ext/boost/token_functions.hpp", "ext/boost/integer_traits.hpp", "ext/boost/mem_fn.hpp", "ext/boost/visit_each.hpp", "ext/boost/VERSION.TXT", "ext/boost/LICENSE.TXT", "ext/boost/iterator/transform_iterator.hpp", "ext/boost/iterator/reverse_iterator.hpp", "ext/boost/iterator/iterator_facade.hpp", "ext/boost/iterator/detail/config_def.hpp", "ext/boost/iterator/detail/enable_if.hpp", "ext/boost/iterator/detail/config_undef.hpp", "ext/boost/iterator/detail/facade_iterator_category.hpp", "ext/boost/iterator/detail/minimum_category.hpp", "ext/boost/iterator/iterator_traits.hpp", "ext/boost/iterator/iterator_adaptor.hpp", "ext/boost/iterator/iterator_categories.hpp", "ext/boost/iterator/interoperable.hpp", "ext/boost/concept/usage.hpp", "ext/boost/concept/assert.hpp", "ext/boost/concept/detail/general.hpp", "ext/boost/concept/detail/concept_undef.hpp", "ext/boost/concept/detail/concept_def.hpp", "ext/boost/concept/detail/has_constraints.hpp", "ext/boost/type_traits/is_pod.hpp", "ext/boost/type_traits/is_member_pointer.hpp", "ext/boost/type_traits/is_member_function_pointer.hpp", "ext/boost/type_traits/broken_compiler_spec.hpp", "ext/boost/type_traits/is_array.hpp", "ext/boost/type_traits/has_nothrow_copy.hpp", "ext/boost/type_traits/is_pointer.hpp", "ext/boost/type_traits/is_integral.hpp", "ext/boost/type_traits/is_scalar.hpp", "ext/boost/type_traits/is_class.hpp", "ext/boost/type_traits/type_with_alignment.hpp", "ext/boost/type_traits/is_volatile.hpp", "ext/boost/type_traits/add_reference.hpp", "ext/boost/type_traits/is_arithmetic.hpp", "ext/boost/type_traits/is_void.hpp", "ext/boost/type_traits/remove_reference.hpp", "ext/boost/type_traits/is_same.hpp", "ext/boost/type_traits/function_traits.hpp", "ext/boost/type_traits/is_const.hpp", "ext/boost/type_traits/is_convertible.hpp", "ext/boost/type_traits/remove_cv.hpp", "ext/boost/type_traits/is_abstract.hpp", "ext/boost/type_traits/integral_constant.hpp", "ext/boost/type_traits/is_union.hpp", "ext/boost/type_traits/detail/ice_and.hpp", "ext/boost/type_traits/detail/bool_trait_def.hpp", "ext/boost/type_traits/detail/ice_or.hpp", "ext/boost/type_traits/detail/yes_no_type.hpp", "ext/boost/type_traits/detail/size_t_trait_undef.hpp", "ext/boost/type_traits/detail/template_arity_spec.hpp", "ext/boost/type_traits/detail/cv_traits_impl.hpp", "ext/boost/type_traits/detail/is_function_ptr_helper.hpp", "ext/boost/type_traits/detail/false_result.hpp", "ext/boost/type_traits/detail/ice_eq.hpp", "ext/boost/type_traits/detail/is_mem_fun_pointer_impl.hpp", "ext/boost/type_traits/detail/type_trait_def.hpp", "ext/boost/type_traits/detail/bool_trait_undef.hpp", "ext/boost/type_traits/detail/type_trait_undef.hpp", "ext/boost/type_traits/detail/size_t_trait_def.hpp", "ext/boost/type_traits/detail/ice_not.hpp", "ext/boost/type_traits/is_enum.hpp", "ext/boost/type_traits/is_float.hpp", "ext/boost/type_traits/is_function.hpp", "ext/boost/type_traits/is_reference.hpp", "ext/boost/type_traits/has_trivial_copy.hpp", "ext/boost/type_traits/add_const.hpp", "ext/boost/type_traits/add_pointer.hpp", "ext/boost/type_traits/composite_traits.hpp", "ext/boost/type_traits/config.hpp", "ext/boost/type_traits/alignment_of.hpp", "ext/boost/type_traits/remove_pointer.hpp", "ext/boost/type_traits/remove_const.hpp", "ext/boost/type_traits/conversion_traits.hpp", "ext/boost/type_traits/intrinsics.hpp", "ext/boost/type_traits/ice.hpp", "ext/boost/preprocessor/array/elem.hpp", "ext/boost/preprocessor/array/data.hpp", "ext/boost/preprocessor/array/size.hpp", "ext/boost/preprocessor/cat.hpp", "ext/boost/preprocessor/arithmetic/sub.hpp", "ext/boost/preprocessor/arithmetic/dec.hpp", "ext/boost/preprocessor/arithmetic/add.hpp", "ext/boost/preprocessor/arithmetic/inc.hpp", "ext/boost/preprocessor/identity.hpp", "ext/boost/preprocessor/iteration/detail/bounds/upper1.hpp", "ext/boost/preprocessor/iteration/detail/bounds/lower1.hpp", "ext/boost/preprocessor/iteration/detail/iter/forward1.hpp", "ext/boost/preprocessor/iteration/iterate.hpp", "ext/boost/preprocessor/tuple/elem.hpp", "ext/boost/preprocessor/tuple/to_list.hpp", "ext/boost/preprocessor/tuple/rem.hpp", "ext/boost/preprocessor/tuple/eat.hpp", "ext/boost/preprocessor/facilities/identity.hpp", "ext/boost/preprocessor/facilities/empty.hpp", "ext/boost/preprocessor/enum_params.hpp", "ext/boost/preprocessor/config/config.hpp", "ext/boost/preprocessor/punctuation/comma.hpp", "ext/boost/preprocessor/punctuation/comma_if.hpp", "ext/boost/preprocessor/stringize.hpp", "ext/boost/preprocessor/detail/auto_rec.hpp", "ext/boost/preprocessor/detail/check.hpp", "ext/boost/preprocessor/detail/is_binary.hpp", "ext/boost/preprocessor/slot/detail/def.hpp", "ext/boost/preprocessor/slot/detail/shared.hpp", "ext/boost/preprocessor/slot/slot.hpp", "ext/boost/preprocessor/debug/error.hpp", "ext/boost/preprocessor/logical/bool.hpp", "ext/boost/preprocessor/logical/bitand.hpp", "ext/boost/preprocessor/logical/compl.hpp", "ext/boost/preprocessor/logical/and.hpp", "ext/boost/preprocessor/seq/for_each_i.hpp", "ext/boost/preprocessor/seq/elem.hpp", "ext/boost/preprocessor/seq/seq.hpp", "ext/boost/preprocessor/seq/enum.hpp", "ext/boost/preprocessor/seq/size.hpp", "ext/boost/preprocessor/empty.hpp", "ext/boost/preprocessor/list/adt.hpp", "ext/boost/preprocessor/list/fold_left.hpp", "ext/boost/preprocessor/list/fold_right.hpp", "ext/boost/preprocessor/list/append.hpp", "ext/boost/preprocessor/list/transform.hpp", "ext/boost/preprocessor/list/for_each_i.hpp", "ext/boost/preprocessor/list/detail/fold_left.hpp", "ext/boost/preprocessor/list/detail/fold_right.hpp", "ext/boost/preprocessor/list/reverse.hpp", "ext/boost/preprocessor/comma_if.hpp", "ext/boost/preprocessor/repeat.hpp", "ext/boost/preprocessor/iterate.hpp", "ext/boost/preprocessor/enum.hpp", "ext/boost/preprocessor/repetition/enum_params.hpp", "ext/boost/preprocessor/repetition/repeat_from_to.hpp", "ext/boost/preprocessor/repetition/for.hpp", "ext/boost/preprocessor/repetition/detail/for.hpp", "ext/boost/preprocessor/repetition/repeat.hpp", "ext/boost/preprocessor/repetition/enum.hpp", "ext/boost/preprocessor/repetition/enum_binary_params.hpp", "ext/boost/preprocessor/inc.hpp", "ext/boost/preprocessor/control/iif.hpp", "ext/boost/preprocessor/control/while.hpp", "ext/boost/preprocessor/control/detail/while.hpp", "ext/boost/preprocessor/control/if.hpp", "ext/boost/preprocessor/control/expr_iif.hpp", "ext/boost/thread/xtime.hpp", "ext/boost/thread/once.hpp", "ext/boost/thread/locks.hpp", "ext/boost/thread/thread_time.hpp", "ext/boost/thread/recursive_mutex.hpp", "ext/boost/thread/detail/platform.hpp", "ext/boost/thread/detail/config.hpp", "ext/boost/thread/detail/move.hpp", "ext/boost/thread/condition.hpp", "ext/boost/thread/condition_variable.hpp", "ext/boost/thread/pthread/thread_data.hpp", "ext/boost/thread/pthread/once.hpp", "ext/boost/thread/pthread/recursive_mutex.hpp", "ext/boost/thread/pthread/timespec.hpp", "ext/boost/thread/pthread/condition_variable_fwd.hpp", "ext/boost/thread/pthread/condition_variable.hpp", "ext/boost/thread/pthread/thread.hpp", "ext/boost/thread/pthread/pthread_mutex_scoped_lock.hpp", "ext/boost/thread/pthread/mutex.hpp", "ext/boost/thread/pthread/tss.hpp", "ext/boost/thread/thread.hpp", "ext/boost/thread/exceptions.hpp", "ext/boost/thread/mutex.hpp", "ext/boost/thread/tss.hpp", "ext/boost/config/select_compiler_config.hpp", "ext/boost/config/abi_suffix.hpp", "ext/boost/config/compiler/gcc.hpp", "ext/boost/config/compiler/sunpro_cc.hpp", "ext/boost/config/compiler/metrowerks.hpp", "ext/boost/config/compiler/vacpp.hpp", "ext/boost/config/compiler/comeau.hpp", "ext/boost/config/compiler/greenhills.hpp", "ext/boost/config/compiler/mpw.hpp", "ext/boost/config/compiler/visualc.hpp", "ext/boost/config/compiler/intel.hpp", "ext/boost/config/compiler/gcc_xml.hpp", "ext/boost/config/compiler/sgi_mipspro.hpp", "ext/boost/config/compiler/compaq_cxx.hpp", "ext/boost/config/compiler/pgi.hpp", "ext/boost/config/compiler/digitalmars.hpp", "ext/boost/config/compiler/common_edg.hpp", "ext/boost/config/compiler/kai.hpp", "ext/boost/config/compiler/borland.hpp", "ext/boost/config/compiler/hp_acc.hpp", "ext/boost/config/abi_prefix.hpp", "ext/boost/config/select_platform_config.hpp", "ext/boost/config/select_stdlib_config.hpp", "ext/boost/config/posix_features.hpp", "ext/boost/config/platform/cygwin.hpp", "ext/boost/config/platform/qnxnto.hpp", "ext/boost/config/platform/beos.hpp", "ext/boost/config/platform/bsd.hpp", "ext/boost/config/platform/aix.hpp", "ext/boost/config/platform/irix.hpp", "ext/boost/config/platform/linux.hpp", "ext/boost/config/platform/win32.hpp", "ext/boost/config/platform/solaris.hpp", "ext/boost/config/platform/macos.hpp", "ext/boost/config/platform/amigaos.hpp", "ext/boost/config/platform/hpux.hpp", "ext/boost/config/no_tr1/complex.hpp", "ext/boost/config/no_tr1/memory.hpp", "ext/boost/config/no_tr1/utility.hpp", "ext/boost/config/no_tr1/functional.hpp", "ext/boost/config/auto_link.hpp", "ext/boost/config/requires_threads.hpp", "ext/boost/config/stdlib/dinkumware.hpp", "ext/boost/config/stdlib/stlport.hpp", "ext/boost/config/stdlib/sgi.hpp", "ext/boost/config/stdlib/vacpp.hpp", "ext/boost/config/stdlib/roguewave.hpp", "ext/boost/config/stdlib/libcomo.hpp", "ext/boost/config/stdlib/msl.hpp", "ext/boost/config/stdlib/libstdcpp3.hpp", "ext/boost/config/stdlib/modena.hpp", "ext/boost/config/suffix.hpp", "ext/boost/config/user.hpp", "ext/boost/config/abi/borland_suffix.hpp", "ext/boost/config/abi/msvc_suffix.hpp", "ext/boost/config/abi/msvc_prefix.hpp", "ext/boost/config/abi/borland_prefix.hpp", "ext/boost/algorithm/string/finder.hpp", "ext/boost/algorithm/string/constants.hpp", "ext/boost/algorithm/string/yes_no_type.hpp", "ext/boost/algorithm/string/find_format.hpp", "ext/boost/algorithm/string/replace.hpp", "ext/boost/algorithm/string/detail/finder.hpp", "ext/boost/algorithm/string/detail/find_format_store.hpp", "ext/boost/algorithm/string/detail/find_format_all.hpp", "ext/boost/algorithm/string/detail/util.hpp", "ext/boost/algorithm/string/detail/find_format.hpp", "ext/boost/algorithm/string/detail/case_conv.hpp", "ext/boost/algorithm/string/detail/replace_storage.hpp", "ext/boost/algorithm/string/detail/sequence.hpp", "ext/boost/algorithm/string/detail/formatter.hpp", "ext/boost/algorithm/string/case_conv.hpp", "ext/boost/algorithm/string/erase.hpp", "ext/boost/algorithm/string/compare.hpp", "ext/boost/algorithm/string/config.hpp", "ext/boost/algorithm/string/concept.hpp", "ext/boost/algorithm/string/formatter.hpp", "ext/boost/algorithm/string/sequence_traits.hpp", "ext/boost/mpl/apply_fwd.hpp", "ext/boost/mpl/next_prior.hpp", "ext/boost/mpl/void.hpp", "ext/boost/mpl/integral_c_tag.hpp", "ext/boost/mpl/not.hpp", "ext/boost/mpl/identity.hpp", "ext/boost/mpl/int.hpp", "ext/boost/mpl/logical.hpp", "ext/boost/mpl/assert.hpp", "ext/boost/mpl/apply_wrap.hpp", "ext/boost/mpl/bind.hpp", "ext/boost/mpl/void_fwd.hpp", "ext/boost/mpl/has_xxx.hpp", "ext/boost/mpl/size_t.hpp", "ext/boost/mpl/int_fwd.hpp", "ext/boost/mpl/or.hpp", "ext/boost/mpl/bool_fwd.hpp", "ext/boost/mpl/arg_fwd.hpp", "ext/boost/mpl/quote.hpp", "ext/boost/mpl/protect.hpp", "ext/boost/mpl/arg.hpp", "ext/boost/mpl/bool.hpp", "ext/boost/mpl/apply.hpp", "ext/boost/mpl/lambda_fwd.hpp", "ext/boost/mpl/limits/arity.hpp", "ext/boost/mpl/bind_fwd.hpp", "ext/boost/mpl/next.hpp", "ext/boost/mpl/if.hpp", "ext/boost/mpl/eval_if.hpp", "ext/boost/mpl/aux_/na_assert.hpp", "ext/boost/mpl/aux_/type_wrapper.hpp", "ext/boost/mpl/aux_/yes_no.hpp", "ext/boost/mpl/aux_/integral_wrapper.hpp", "ext/boost/mpl/aux_/include_preprocessed.hpp", "ext/boost/mpl/aux_/full_lambda.hpp", "ext/boost/mpl/aux_/preprocessor/def_params_tail.hpp", "ext/boost/mpl/aux_/preprocessor/sub.hpp", "ext/boost/mpl/aux_/preprocessor/filter_params.hpp", "ext/boost/mpl/aux_/preprocessor/enum.hpp", "ext/boost/mpl/aux_/preprocessor/params.hpp", "ext/boost/mpl/aux_/static_cast.hpp", "ext/boost/mpl/aux_/preprocessed/gcc/apply_fwd.hpp", "ext/boost/mpl/aux_/preprocessed/gcc/full_lambda.hpp", "ext/boost/mpl/aux_/preprocessed/gcc/apply_wrap.hpp", "ext/boost/mpl/aux_/preprocessed/gcc/bind.hpp", "ext/boost/mpl/aux_/preprocessed/gcc/or.hpp", "ext/boost/mpl/aux_/preprocessed/gcc/template_arity.hpp", "ext/boost/mpl/aux_/preprocessed/gcc/quote.hpp", "ext/boost/mpl/aux_/preprocessed/gcc/arg.hpp", "ext/boost/mpl/aux_/preprocessed/gcc/apply.hpp", "ext/boost/mpl/aux_/preprocessed/gcc/bind_fwd.hpp", "ext/boost/mpl/aux_/preprocessed/gcc/placeholders.hpp", "ext/boost/mpl/aux_/preprocessed/gcc/and.hpp", "ext/boost/mpl/aux_/value_wknd.hpp", "ext/boost/mpl/aux_/config/gcc.hpp", "ext/boost/mpl/aux_/config/adl.hpp", "ext/boost/mpl/aux_/config/overload_resolution.hpp", "ext/boost/mpl/aux_/config/workaround.hpp", "ext/boost/mpl/aux_/config/bind.hpp", "ext/boost/mpl/aux_/config/has_xxx.hpp", "ext/boost/mpl/aux_/config/preprocessor.hpp", "ext/boost/mpl/aux_/config/pp_counter.hpp", "ext/boost/mpl/aux_/config/nttp.hpp", "ext/boost/mpl/aux_/config/dtp.hpp", "ext/boost/mpl/aux_/config/integral.hpp", "ext/boost/mpl/aux_/config/ctps.hpp", "ext/boost/mpl/aux_/config/intel.hpp", "ext/boost/mpl/aux_/config/static_constant.hpp", "ext/boost/mpl/aux_/config/arrays.hpp", "ext/boost/mpl/aux_/config/msvc_typename.hpp", "ext/boost/mpl/aux_/config/eti.hpp", "ext/boost/mpl/aux_/config/use_preprocessed.hpp", "ext/boost/mpl/aux_/config/has_apply.hpp", "ext/boost/mpl/aux_/config/msvc.hpp", "ext/boost/mpl/aux_/config/lambda.hpp", "ext/boost/mpl/aux_/config/ttp.hpp", "ext/boost/mpl/aux_/config/compiler.hpp", "ext/boost/mpl/aux_/na_fwd.hpp", "ext/boost/mpl/aux_/arity_spec.hpp", "ext/boost/mpl/aux_/arg_typedef.hpp", "ext/boost/mpl/aux_/template_arity_fwd.hpp", "ext/boost/mpl/aux_/na_spec.hpp", "ext/boost/mpl/aux_/adl_barrier.hpp", "ext/boost/mpl/aux_/lambda_support.hpp", "ext/boost/mpl/aux_/template_arity.hpp", "ext/boost/mpl/aux_/arity.hpp", "ext/boost/mpl/aux_/nested_type_wknd.hpp", "ext/boost/mpl/aux_/lambda_arity_param.hpp", "ext/boost/mpl/aux_/has_type.hpp", "ext/boost/mpl/aux_/msvc_never_true.hpp", "ext/boost/mpl/aux_/nttp_decl.hpp", "ext/boost/mpl/aux_/has_apply.hpp", "ext/boost/mpl/aux_/na.hpp", "ext/boost/mpl/aux_/common_name_wknd.hpp", "ext/boost/mpl/always.hpp", "ext/boost/mpl/placeholders.hpp", "ext/boost/mpl/integral_c.hpp", "ext/boost/mpl/and.hpp", "ext/boost/mpl/lambda.hpp", "ext/boost/mpl/integral_c_fwd.hpp", "ext/boost/mpl/size_t_fwd.hpp", "ext/boost/detail/sp_counted_base_cw_ppc.hpp", "ext/boost/detail/sp_counted_base_gcc_sparc.hpp", "ext/boost/detail/sp_counted_base.hpp", "ext/boost/detail/sp_counted_base_w32.hpp", "ext/boost/detail/sp_counted_base_nt.hpp", "ext/boost/detail/bad_weak_ptr.hpp", "ext/boost/detail/call_traits.hpp", "ext/boost/detail/sp_typeinfo.hpp", "ext/boost/detail/sp_counted_base_sync.hpp", "ext/boost/detail/atomic_count_gcc_x86.hpp", "ext/boost/detail/workaround.hpp", "ext/boost/detail/atomic_count_pthreads.hpp", "ext/boost/detail/indirect_traits.hpp", "ext/boost/detail/sp_counted_base_pt.hpp", "ext/boost/detail/sp_counted_base_gcc_ia64.hpp", "ext/boost/detail/sp_counted_base_acc_ia64.hpp", "ext/boost/detail/endian.hpp", "ext/boost/detail/sp_counted_base_cw_x86.hpp", "ext/boost/detail/atomic_count.hpp", "ext/boost/detail/sp_counted_base_gcc_x86.hpp", "ext/boost/detail/atomic_count_solaris.hpp", "ext/boost/detail/limits.hpp", "ext/boost/detail/sp_counted_impl.hpp", "ext/boost/detail/atomic_count_gcc.hpp", "ext/boost/detail/atomic_count_win32.hpp", "ext/boost/detail/iterator.hpp", "ext/boost/detail/atomic_count_sync.hpp", "ext/boost/detail/lcast_precision.hpp", "ext/boost/detail/sp_counted_base_solaris.hpp", "ext/boost/detail/sp_counted_base_gcc_ppc.hpp", "ext/boost/detail/reference_content.hpp", "ext/boost/detail/shared_count.hpp", "ext/boost/date_time/strings_from_facet.hpp", "ext/boost/date_time/format_date_parser.hpp", "ext/boost/date_time/period_parser.hpp", "ext/boost/date_time/dst_rules.hpp", "ext/boost/date_time/time_resolution_traits.hpp", "ext/boost/date_time/date_generator_parser.hpp", "ext/boost/date_time/locale_config.hpp", "ext/boost/date_time/string_parse_tree.hpp", "ext/boost/date_time/date_clock_device.hpp", "ext/boost/date_time/date_formatting.hpp", "ext/boost/date_time/compiler_config.hpp", "ext/boost/date_time/date_iterator.hpp", "ext/boost/date_time/date_generator_formatter.hpp", "ext/boost/date_time/time_duration.hpp", "ext/boost/date_time/period.hpp", "ext/boost/date_time/time_system_split.hpp", "ext/boost/date_time/c_time.hpp", "ext/boost/date_time/gregorian/greg_day.hpp", "ext/boost/date_time/gregorian/greg_date.hpp", "ext/boost/date_time/gregorian/greg_duration.hpp", "ext/boost/date_time/gregorian/greg_day_of_year.hpp", "ext/boost/date_time/gregorian/greg_weekday.hpp", "ext/boost/date_time/gregorian/greg_calendar.hpp", "ext/boost/date_time/gregorian/greg_year.hpp", "ext/boost/date_time/gregorian/conversion.hpp", "ext/boost/date_time/gregorian/greg_ymd.hpp", "ext/boost/date_time/gregorian/gregorian.hpp", "ext/boost/date_time/gregorian/greg_month.hpp", "ext/boost/date_time/gregorian/parsers.hpp", "ext/boost/date_time/gregorian/formatters.hpp", "ext/boost/date_time/gregorian/greg_duration_types.hpp", "ext/boost/date_time/gregorian/gregorian_io.hpp", "ext/boost/date_time/gregorian/formatters_limited.hpp", "ext/boost/date_time/gregorian/gregorian_types.hpp", "ext/boost/date_time/special_defs.hpp", "ext/boost/date_time/date_formatting_limited.hpp", "ext/boost/date_time/date_formatting_locales.hpp", "ext/boost/date_time/date.hpp", "ext/boost/date_time/microsec_time_clock.hpp", "ext/boost/date_time/date_facet.hpp", "ext/boost/date_time/parse_format_base.hpp", "ext/boost/date_time/time_defs.hpp", "ext/boost/date_time/date_duration.hpp", "ext/boost/date_time/time_clock.hpp", "ext/boost/date_time/posix_time/posix_time_system.hpp", "ext/boost/date_time/posix_time/posix_time_config.hpp", "ext/boost/date_time/posix_time/time_parsers.hpp", "ext/boost/date_time/posix_time/time_formatters.hpp", "ext/boost/date_time/posix_time/conversion.hpp", "ext/boost/date_time/posix_time/date_duration_operators.hpp", "ext/boost/date_time/posix_time/posix_time.hpp", "ext/boost/date_time/posix_time/posix_time_duration.hpp", "ext/boost/date_time/posix_time/posix_time_types.hpp", "ext/boost/date_time/posix_time/ptime.hpp", "ext/boost/date_time/posix_time/posix_time_io.hpp", "ext/boost/date_time/posix_time/time_period.hpp", "ext/boost/date_time/year_month_day.hpp", "ext/boost/date_time/date_defs.hpp", "ext/boost/date_time/time_system_counted.hpp", "ext/boost/date_time/time_facet.hpp", "ext/boost/date_time/special_values_parser.hpp", "ext/boost/date_time/time_parsing.hpp", "ext/boost/date_time/filetime_functions.hpp", "ext/boost/date_time/special_values_formatter.hpp", "ext/boost/date_time/wrapping_int.hpp", "ext/boost/date_time/date_generators.hpp", "ext/boost/date_time/date_format_simple.hpp", "ext/boost/date_time/gregorian_calendar.hpp", "ext/boost/date_time/date_parsing.hpp", "ext/boost/date_time/date_names_put.hpp", "ext/boost/date_time/time_iterator.hpp", "ext/boost/date_time/period_formatter.hpp", "ext/boost/date_time/date_duration_types.hpp", "ext/boost/date_time/string_convert.hpp", "ext/boost/date_time/int_adapter.hpp", "ext/boost/date_time/time_formatting_streams.hpp", "ext/boost/date_time/constrained_value.hpp", "ext/boost/date_time/time.hpp", "ext/boost/date_time/adjust_functors.hpp", "ext/boost/date_time/iso_format.hpp", "ext/boost/utility/enable_if.hpp", "ext/boost/utility/addressof.hpp", "ext/boost/utility/compare_pointees.hpp", "ext/boost/utility/base_from_member.hpp", "ext/boost/bind/mem_fn_cc.hpp", "ext/boost/bind/bind_cc.hpp", "ext/boost/bind/storage.hpp", "ext/boost/bind/bind_template.hpp", "ext/boost/bind/bind_mf_cc.hpp", "ext/boost/bind/arg.hpp", "ext/boost/bind/placeholders.hpp", "ext/boost/bind/mem_fn_template.hpp", "ext/boost/io/ios_state.hpp", "ext/boost/function/detail/function_iterate.hpp", "ext/boost/function/detail/prologue.hpp", "ext/boost/function/detail/maybe_include.hpp", "ext/boost/function/function_base.hpp", "ext/boost/function/function_template.hpp", "ext/boost/range/as_literal.hpp", "ext/boost/range/rbegin.hpp", "ext/boost/range/iterator_range.hpp", "ext/boost/range/rend.hpp", "ext/boost/range/size_type.hpp", "ext/boost/range/reverse_iterator.hpp", "ext/boost/range/begin.hpp", "ext/boost/range/mutable_iterator.hpp", "ext/boost/range/detail/sfinae.hpp", "ext/boost/range/detail/common.hpp", "ext/boost/range/detail/str_types.hpp", "ext/boost/range/detail/implementation_help.hpp", "ext/boost/range/distance.hpp", "ext/boost/range/const_iterator.hpp", "ext/boost/range/empty.hpp", "ext/boost/range/iterator.hpp", "ext/boost/range/difference_type.hpp", "ext/boost/range/config.hpp", "ext/boost/range/functions.hpp", "ext/boost/range/size.hpp", "ext/boost/range/end.hpp", "ext/boost/range/value_type.hpp", "ext/boost/optional/optional.hpp", "ext/boost/optional/optional_fwd.hpp", "ext/boost/src/tss_null.cpp", "ext/boost/src/pthread/once.cpp", "ext/boost/src/pthread/exceptions.cpp", "ext/boost/src/pthread/thread.cpp", "ext/boost/src/win32/tss_pe.cpp", "ext/boost/src/win32/tss_dll.cpp", "ext/boost/src/win32/exceptions.cpp", "ext/boost/src/win32/thread.cpp", "ext/boost/src/pthread/timeconv.inl", "ext/boost/src/win32/timeconv.inl", "ext/boost/date_time/gregorian_calendar.ipp", "ext/oxt/backtrace.hpp", "ext/oxt/system_calls.hpp", "ext/oxt/tracable_exception.hpp", "ext/oxt/macros.hpp", "ext/oxt/thread.hpp", "ext/oxt/spin_lock.hpp", "ext/oxt/backtrace.cpp", "ext/oxt/tracable_exception.cpp", "ext/oxt/system_calls.cpp", "ext/oxt/thread.cpp", "ext/oxt/detail/backtrace_disabled.hpp", "ext/oxt/detail/backtrace_enabled.hpp", "ext/oxt/detail/spin_lock_gcc_x86.hpp", "ext/oxt/detail/spin_lock_portable.hpp", "ext/oxt/detail/tracable_exception_enabled.hpp", "ext/oxt/detail/spin_lock_pthreads.hpp", "ext/oxt/detail/tracable_exception_disabled.hpp", "ext/phusion_passenger/native_support.c", "ext/phusion_passenger/extconf.rb", "benchmark/DummyRequestHandler.cpp", "benchmark/ApplicationPool.cpp", "benchmark/unix_sockets_vs_pipes.rb", "benchmark/accept_vs_socketpair_vs_named_pipes.rb", "benchmark/overhead_of_password_checking.rb", "benchmark/socket_connections_vs_persistent_pipe.rb", "benchmark/dispatcher.rb", "misc/find_owner_pipe_leaks.rb", "misc/copy_boost_headers.rb", "misc/render_error_pages.rb", "misc/rake", "misc/rake/extensions.rb", "misc/rake/gempackagetask.rb", "misc/rake/packagetask.rb", "misc/rake/cplusplus.rb", "misc/rake/rdoctask.rb", "vendor/README_FOR_PACKAGERS", "vendor/README", "vendor/rack-0.9.1", "vendor/rack-0.9.1/AUTHORS", "vendor/rack-0.9.1/ChangeLog", "vendor/rack-0.9.1/README", "vendor/rack-0.9.1/lib", "vendor/rack-0.9.1/lib/rack", "vendor/rack-0.9.1/lib/rack/request.rb", "vendor/rack-0.9.1/lib/rack/session", "vendor/rack-0.9.1/lib/rack/session/pool.rb", "vendor/rack-0.9.1/lib/rack/session/abstract", "vendor/rack-0.9.1/lib/rack/session/abstract/id.rb", "vendor/rack-0.9.1/lib/rack/session/cookie.rb", "vendor/rack-0.9.1/lib/rack/session/memcache.rb", "vendor/rack-0.9.1/lib/rack/reloader.rb", "vendor/rack-0.9.1/lib/rack/mime.rb", "vendor/rack-0.9.1/lib/rack/commonlogger.rb", "vendor/rack-0.9.1/lib/rack/auth", "vendor/rack-0.9.1/lib/rack/auth/basic.rb", "vendor/rack-0.9.1/lib/rack/auth/openid.rb", "vendor/rack-0.9.1/lib/rack/auth/abstract", "vendor/rack-0.9.1/lib/rack/auth/abstract/request.rb", "vendor/rack-0.9.1/lib/rack/auth/abstract/handler.rb", "vendor/rack-0.9.1/lib/rack/auth/digest", "vendor/rack-0.9.1/lib/rack/auth/digest/request.rb", "vendor/rack-0.9.1/lib/rack/auth/digest/md5.rb", "vendor/rack-0.9.1/lib/rack/auth/digest/nonce.rb", "vendor/rack-0.9.1/lib/rack/auth/digest/params.rb", "vendor/rack-0.9.1/lib/rack/head.rb", "vendor/rack-0.9.1/lib/rack/handler", "vendor/rack-0.9.1/lib/rack/handler/cgi.rb", "vendor/rack-0.9.1/lib/rack/handler/evented_mongrel.rb", "vendor/rack-0.9.1/lib/rack/handler/scgi.rb", "vendor/rack-0.9.1/lib/rack/handler/fastcgi.rb", "vendor/rack-0.9.1/lib/rack/handler/webrick.rb", "vendor/rack-0.9.1/lib/rack/handler/swiftiplied_mongrel.rb", "vendor/rack-0.9.1/lib/rack/handler/mongrel.rb", "vendor/rack-0.9.1/lib/rack/handler/thin.rb", "vendor/rack-0.9.1/lib/rack/handler/lsws.rb", "vendor/rack-0.9.1/lib/rack/showexceptions.rb", "vendor/rack-0.9.1/lib/rack/lint.rb", "vendor/rack-0.9.1/lib/rack/cascade.rb", "vendor/rack-0.9.1/lib/rack/mock.rb", "vendor/rack-0.9.1/lib/rack/response.rb", "vendor/rack-0.9.1/lib/rack/adapter", "vendor/rack-0.9.1/lib/rack/adapter/camping.rb", "vendor/rack-0.9.1/lib/rack/conditionalget.rb", "vendor/rack-0.9.1/lib/rack/showstatus.rb", "vendor/rack-0.9.1/lib/rack/urlmap.rb", "vendor/rack-0.9.1/lib/rack/handler.rb", "vendor/rack-0.9.1/lib/rack/file.rb", "vendor/rack-0.9.1/lib/rack/content_length.rb", "vendor/rack-0.9.1/lib/rack/methodoverride.rb", "vendor/rack-0.9.1/lib/rack/static.rb", "vendor/rack-0.9.1/lib/rack/recursive.rb", "vendor/rack-0.9.1/lib/rack/utils.rb", "vendor/rack-0.9.1/lib/rack/lobster.rb", "vendor/rack-0.9.1/lib/rack/deflater.rb", "vendor/rack-0.9.1/lib/rack/builder.rb", "vendor/rack-0.9.1/lib/rack/directory.rb", "vendor/rack-0.9.1/lib/rack.rb", "vendor/rack-0.9.1/SPEC", "vendor/rack-0.9.1/Rakefile", "vendor/rack-0.9.1/KNOWN-ISSUES", "vendor/rack-0.9.1/COPYING", "test/integration_tests.rb", "test/ApplicationPoolServerTest.cpp", "test/MessageChannelTest.cpp", "test/SpawnManagerTest.cpp", "test/ApplicationPoolServer_ApplicationPoolTest.cpp", "test/CachedFileStatTest.cpp", "test/UtilsTest.cpp", "test/SystemTimeTest.cpp", "test/StandardApplicationPoolTest.cpp", "test/CxxTestMain.cpp", "test/PoolOptionsTest.cpp", "test/FileCheckerTest.cpp", "test/ApplicationPoolTest.cpp", "test/config.yml.example", "test/support/config.rb", "test/support/multipart.rb", "test/support/run_rspec_tests.rb", "test/support/apache2_controller.rb", "test/support/tut_reporter.h", "test/support/tut.h", "test/support/test_helper.rb", "test/support/valgrind.h", "test/oxt/oxt_test_main.cpp", "test/oxt/syscall_interruption_test.cpp", "test/oxt/backtrace_test.cpp", "test/ruby/spawn_manager_spec.rb", "test/ruby/wsgi", "test/ruby/application_spec.rb", "test/ruby/rack", "test/ruby/abstract_server_collection_spec.rb", "test/ruby/message_channel_spec.rb", "test/ruby/rails", "test/ruby/spawn_server_spec.rb", "test/ruby/abstract_server_spec.rb", "test/ruby/abstract_request_handler_spec.rb", "test/ruby/utils_spec.rb", "test/ruby/wsgi/application_spawner_spec.rb", "test/ruby/rack/application_spawner_spec.rb", "test/ruby/rails/spawner_error_handling_spec.rb", "test/ruby/rails/minimal_spawner_spec.rb", "test/ruby/rails/application_spawner_spec.rb", "test/ruby/rails/spawner_privilege_lowering_spec.rb", "test/ruby/rails/framework_spawner_spec.rb", "test/stub/garbage3.dat", "test/stub/http_request.yml", "test/stub/rails_apps", "test/stub/apache2", "test/stub/garbage2.dat", "test/stub/wsgi", "test/stub/railsapp", "test/stub/garbage1.dat", "test/stub/vendor_rails", "test/stub/upload_data.txt", "test/stub/minimal-railsapp", "test/stub/message_channel_2.rb", "test/stub/message_channel.rb", "test/stub/rack", "test/stub/message_channel_3.rb", "test/stub/zsfa", "test/stub/spawn_server.rb", "test/stub/railsapp2", "test/stub/rails_apps/foobar", "test/stub/rails_apps/mycook", "test/stub/apache2/httpd.conf.erb", "test/stub/apache2/mime.types", "test/stub/wsgi/passenger_wsgi.py", "test/stub/wsgi/public", "test/stub/wsgi/passenger_wsgi.pyc", "test/stub/wsgi/tmp", "test/stub/railsapp/app", "test/stub/railsapp/config", "test/stub/railsapp/public", "test/stub/railsapp/log", "test/stub/railsapp/tmp", "test/stub/vendor_rails/minimal", "test/stub/minimal-railsapp/vendor", "test/stub/minimal-railsapp/README", "test/stub/minimal-railsapp/config", "test/stub/rack/public", "test/stub/rack/config.ru", "test/stub/rack/tmp", "test/stub/zsfa/header.png", "test/stub/zsfa/zsfa.png", "test/stub/zsfa/index.html", "test/stub/railsapp2/app", "test/stub/railsapp2/config", "test/stub/railsapp2/public", "test/stub/railsapp2/log", "test/stub/railsapp2/tmp", "test/stub/rails_apps/foobar/app", "test/stub/rails_apps/foobar/config", "test/stub/rails_apps/foobar/public", "test/stub/rails_apps/foobar/log", "test/stub/rails_apps/foobar/tmp", "test/stub/rails_apps/mycook/app", "test/stub/rails_apps/mycook/config", "test/stub/rails_apps/mycook/public", "test/stub/rails_apps/mycook/sites", "test/stub/rails_apps/mycook/log", "test/stub/rails_apps/mycook/tmp", "test/stub/wsgi/public/wsgi-snake.jpg", "test/stub/railsapp/app/controllers", "test/stub/railsapp/app/helpers", "test/stub/railsapp/config/routes.rb", "test/stub/railsapp/config/environments", "test/stub/railsapp/config/environment.rb", "test/stub/railsapp/config/boot.rb", "test/stub/railsapp/config/initializers", "test/stub/railsapp/config/database.yml", "test/stub/railsapp/public/useless.txt", "test/stub/railsapp/tmp/cache", "test/stub/railsapp/tmp/restart.txt", "test/stub/railsapp/tmp/sockets", "test/stub/railsapp/tmp/sessions", "test/stub/railsapp/tmp/pids", "test/stub/vendor_rails/minimal/actionpack", "test/stub/vendor_rails/minimal/README", "test/stub/vendor_rails/minimal/activesupport", "test/stub/vendor_rails/minimal/activerecord", "test/stub/vendor_rails/minimal/activeresource", "test/stub/vendor_rails/minimal/railties", "test/stub/vendor_rails/minimal/actionmailer", "test/stub/minimal-railsapp/vendor/rails", "test/stub/minimal-railsapp/config/application.rb", "test/stub/minimal-railsapp/config/environment.rb", "test/stub/rack/public/rack.jpg", "test/stub/railsapp2/app/controllers", "test/stub/railsapp2/app/helpers", "test/stub/railsapp2/config/routes.rb", "test/stub/railsapp2/config/environments", "test/stub/railsapp2/config/environment.rb", "test/stub/railsapp2/config/boot.rb", "test/stub/railsapp2/config/initializers", "test/stub/railsapp2/config/database.yml", "test/stub/railsapp2/public/useless.txt", "test/stub/railsapp2/tmp/cache", "test/stub/railsapp2/tmp/sockets", "test/stub/railsapp2/tmp/sessions", "test/stub/railsapp2/tmp/pids", "test/stub/rails_apps/foobar/app/controllers", "test/stub/rails_apps/foobar/app/helpers", "test/stub/rails_apps/foobar/config/routes.rb", "test/stub/rails_apps/foobar/config/environments", "test/stub/rails_apps/foobar/config/environment.rb", "test/stub/rails_apps/foobar/config/boot.rb", "test/stub/rails_apps/foobar/config/initializers", "test/stub/rails_apps/foobar/config/database.yml", "test/stub/rails_apps/foobar/tmp/cache", "test/stub/rails_apps/foobar/tmp/sockets", "test/stub/rails_apps/foobar/tmp/sessions", "test/stub/rails_apps/foobar/tmp/pids", "test/stub/rails_apps/mycook/app/views", "test/stub/rails_apps/mycook/app/controllers", "test/stub/rails_apps/mycook/app/helpers", "test/stub/rails_apps/mycook/config/routes.rb", "test/stub/rails_apps/mycook/config/environments", "test/stub/rails_apps/mycook/config/environment.rb", "test/stub/rails_apps/mycook/config/boot.rb", "test/stub/rails_apps/mycook/config/initializers", "test/stub/rails_apps/mycook/config/database.yml", "test/stub/rails_apps/mycook/public/dispatch.cgi", "test/stub/rails_apps/mycook/public/images", "test/stub/rails_apps/mycook/public/404.html", "test/stub/rails_apps/mycook/public/favicon.ico", "test/stub/rails_apps/mycook/public/dispatch.rb", "test/stub/rails_apps/mycook/public/uploads.html", "test/stub/rails_apps/mycook/public/javascripts", "test/stub/rails_apps/mycook/public/500.html", "test/stub/rails_apps/mycook/public/robots.txt", "test/stub/rails_apps/mycook/public/dispatch.fcgi", "test/stub/rails_apps/mycook/public/422.html", "test/stub/rails_apps/mycook/public/welcome", "test/stub/rails_apps/mycook/sites/some.site", "test/stub/rails_apps/mycook/log/useless.txt", "test/stub/rails_apps/mycook/tmp/cache", "test/stub/rails_apps/mycook/tmp/sockets", "test/stub/rails_apps/mycook/tmp/sessions", "test/stub/rails_apps/mycook/tmp/pids", "test/stub/railsapp/app/controllers/application.rb", "test/stub/railsapp/app/controllers/foo_controller.rb", "test/stub/railsapp/app/controllers/bar_controller_2.rb", "test/stub/railsapp/app/controllers/bar_controller_1.rb", "test/stub/railsapp/app/helpers/application_helper.rb", "test/stub/railsapp/config/environments/development.rb", "test/stub/railsapp/config/environments/production.rb", "test/stub/railsapp/config/initializers/mime_types.rb", "test/stub/railsapp/config/initializers/inflections.rb", "test/stub/vendor_rails/minimal/actionpack/lib", "test/stub/vendor_rails/minimal/activesupport/lib", "test/stub/vendor_rails/minimal/activerecord/lib", "test/stub/vendor_rails/minimal/activeresource/lib", "test/stub/vendor_rails/minimal/railties/lib", "test/stub/vendor_rails/minimal/actionmailer/lib", "test/stub/minimal-railsapp/vendor/rails/actionpack", "test/stub/minimal-railsapp/vendor/rails/activesupport", "test/stub/minimal-railsapp/vendor/rails/activerecord", "test/stub/minimal-railsapp/vendor/rails/activeresource", "test/stub/minimal-railsapp/vendor/rails/railties", "test/stub/minimal-railsapp/vendor/rails/actionmailer", "test/stub/railsapp2/app/controllers/application.rb", "test/stub/railsapp2/app/controllers/foo_controller.rb", "test/stub/railsapp2/app/helpers/application_helper.rb", "test/stub/railsapp2/config/environments/development.rb", "test/stub/railsapp2/config/environments/production.rb", "test/stub/railsapp2/config/initializers/mime_types.rb", "test/stub/railsapp2/config/initializers/inflections.rb", "test/stub/rails_apps/foobar/app/controllers/application.rb", "test/stub/rails_apps/foobar/app/controllers/foo_controller.rb", "test/stub/rails_apps/foobar/app/controllers/bar_controller_2.rb", "test/stub/rails_apps/foobar/app/controllers/bar_controller_1.rb", "test/stub/rails_apps/foobar/app/helpers/application_helper.rb", "test/stub/rails_apps/foobar/config/environments/development.rb", "test/stub/rails_apps/foobar/config/environments/production.rb", "test/stub/rails_apps/foobar/config/initializers/mime_types.rb", "test/stub/rails_apps/foobar/config/initializers/inflections.rb", "test/stub/rails_apps/mycook/app/views/layouts", "test/stub/rails_apps/mycook/app/views/recipes", "test/stub/rails_apps/mycook/app/views/uploads", "test/stub/rails_apps/mycook/app/views/welcome", "test/stub/rails_apps/mycook/app/controllers/uploads_controller.rb", "test/stub/rails_apps/mycook/app/controllers/welcome_controller.rb", "test/stub/rails_apps/mycook/app/controllers/application.rb", "test/stub/rails_apps/mycook/app/controllers/recipes_controller.rb", "test/stub/rails_apps/mycook/app/helpers/application_helper.rb", "test/stub/rails_apps/mycook/config/environments/development.rb", "test/stub/rails_apps/mycook/config/environments/production.rb", "test/stub/rails_apps/mycook/config/initializers/mime_types.rb", "test/stub/rails_apps/mycook/config/initializers/inflections.rb", "test/stub/rails_apps/mycook/public/images/rails.png", "test/stub/rails_apps/mycook/public/images/header.png", "test/stub/rails_apps/mycook/public/images/cookbook.gif", "test/stub/rails_apps/mycook/public/images/angrywizard.gif", "test/stub/rails_apps/mycook/public/javascripts/effects.js", "test/stub/rails_apps/mycook/public/javascripts/prototype.js", "test/stub/rails_apps/mycook/public/javascripts/application.js", "test/stub/rails_apps/mycook/public/javascripts/controls.js", "test/stub/rails_apps/mycook/public/javascripts/dragdrop.js", "test/stub/rails_apps/mycook/public/welcome/cached.html", "test/stub/rails_apps/mycook/sites/some.site/public", "test/stub/rails_apps/mycook/tmp/cache/useless.txt", "test/stub/rails_apps/mycook/tmp/sockets/useless.txt", "test/stub/rails_apps/mycook/tmp/sessions/useless.txt", "test/stub/rails_apps/mycook/tmp/pids/useless.txt", "test/stub/vendor_rails/minimal/actionpack/lib/action_pack.rb", "test/stub/vendor_rails/minimal/actionpack/lib/action_controller.rb", "test/stub/vendor_rails/minimal/actionpack/lib/action_view.rb", "test/stub/vendor_rails/minimal/activesupport/lib/active_support", "test/stub/vendor_rails/minimal/activesupport/lib/active_support.rb", "test/stub/vendor_rails/minimal/activerecord/lib/active_record.rb", "test/stub/vendor_rails/minimal/activeresource/lib/active_resource.rb", "test/stub/vendor_rails/minimal/railties/lib/initializer.rb", "test/stub/vendor_rails/minimal/railties/lib/ruby_version_check.rb", "test/stub/vendor_rails/minimal/railties/lib/dispatcher.rb", "test/stub/vendor_rails/minimal/actionmailer/lib/action_mailer.rb", "test/stub/minimal-railsapp/vendor/rails/actionpack/lib", "test/stub/minimal-railsapp/vendor/rails/activesupport/lib", "test/stub/minimal-railsapp/vendor/rails/activerecord/lib", "test/stub/minimal-railsapp/vendor/rails/activeresource/lib", "test/stub/minimal-railsapp/vendor/rails/railties/lib", "test/stub/minimal-railsapp/vendor/rails/actionmailer/lib", "test/stub/rails_apps/mycook/app/views/layouts/default.rhtml", "test/stub/rails_apps/mycook/app/views/recipes/create.rhtml", "test/stub/rails_apps/mycook/app/views/recipes/new.rhtml", "test/stub/rails_apps/mycook/app/views/recipes/index.rhtml", "test/stub/rails_apps/mycook/app/views/uploads/new.html.erb", "test/stub/rails_apps/mycook/app/views/uploads/index.rhtml", "test/stub/rails_apps/mycook/app/views/welcome/cached.rhtml", "test/stub/rails_apps/mycook/app/views/welcome/index.rhtml", "test/stub/rails_apps/mycook/sites/some.site/public/uploads.html", "test/stub/rails_apps/mycook/sites/some.site/public/welcome", "test/stub/vendor_rails/minimal/activesupport/lib/active_support/whiny_nil.rb", "test/stub/minimal-railsapp/vendor/rails/actionpack/lib/action_pack.rb", "test/stub/minimal-railsapp/vendor/rails/actionpack/lib/action_controller.rb", "test/stub/minimal-railsapp/vendor/rails/actionpack/lib/action_view.rb", "test/stub/minimal-railsapp/vendor/rails/activesupport/lib/active_support", "test/stub/minimal-railsapp/vendor/rails/activesupport/lib/active_support.rb", "test/stub/minimal-railsapp/vendor/rails/activerecord/lib/active_record.rb", "test/stub/minimal-railsapp/vendor/rails/activeresource/lib/active_resource.rb", "test/stub/minimal-railsapp/vendor/rails/railties/lib/initializer.rb", "test/stub/minimal-railsapp/vendor/rails/railties/lib/ruby_version_check.rb", "test/stub/minimal-railsapp/vendor/rails/railties/lib/dispatcher.rb", "test/stub/minimal-railsapp/vendor/rails/actionmailer/lib/action_mailer.rb", "test/stub/rails_apps/mycook/sites/some.site/public/welcome/cached.html", "test/stub/minimal-railsapp/vendor/rails/activesupport/lib/active_support/whiny_nil.rb"]
  s.has_rdoc = true
  s.homepage = %q{http://www.modrails.com/}
  s.rdoc_options = ["-S", "-N", "-p", "-H", "--main", "README", "--title", "Passenger Ruby API"]
  s.require_paths = ["lib", "ext"]
  s.requirements = ["fastthread", "Apache 2 with development headers"]
  s.rubyforge_project = %q{passenger}
  s.rubygems_version = %q{1.3.1}
  s.summary = %q{Apache module for Ruby on Rails support.}

  if s.respond_to? :specification_version then
    current_version = Gem::Specification::CURRENT_SPECIFICATION_VERSION
    s.specification_version = 2

    if Gem::Version.new(Gem::RubyGemsVersion) >= Gem::Version.new('1.2.0') then
      s.add_runtime_dependency(%q<rake>, [">= 0.8.1"])
      s.add_runtime_dependency(%q<fastthread>, [">= 1.0.1"])
    else
      s.add_dependency(%q<rake>, [">= 0.8.1"])
      s.add_dependency(%q<fastthread>, [">= 1.0.1"])
    end
  else
    s.add_dependency(%q<rake>, [">= 0.8.1"])
    s.add_dependency(%q<fastthread>, [">= 1.0.1"])
  end
end
